#import "ClockView.h"

@implementation ClockView

- init
{
   posHour = NSMakePoint(0,0);
   posMinute = NSMakePoint(0,0);
   [super init];
}

- (void) drawRect: (NSRect) frame
{
   NSPoint origin = NSMakePoint(frame.size.width/2, frame.size.height/2);

   NSBezierPath *bp = [NSBezierPath bezierPathWithRect: [self bounds]];
   [[NSColor yellowColor] set];
   [bp fill];

   bp = [NSBezierPath bezierPathWithRect: NSMakeRect(1, 1,
                                                     frame.size.width-2,
                                                     frame.size.height-2)];
   [[NSColor blackColor] set];
   [bp stroke];

   bp = [NSBezierPath bezierPath];
   [bp setLineWidth: 3];
   [bp moveToPoint: origin];
   [bp relativeLineToPoint: posHour];
   [bp stroke];

   [bp setLineWidth: 1];
   [bp moveToPoint: origin];
   [bp relativeLineToPoint: posMinute];
   [bp stroke];
}

- (void) setDate: (NSCalendarDate *) date;
{
   int hour = [date hourOfDay];
   int minute = [date minuteOfHour];
   float hour_x = 40*sin((M_PI*hour/6)+(M_PI*minute/360));
   float hour_y = 40*cos((M_PI*hour/6)+(M_PI*minute/360));
   float minute_x = 60*sin(M_PI*minute/30);
   float minute_y = 60*cos(M_PI*minute/30);

   posHour = NSMakePoint(hour_x, hour_y);
   posMinute = NSMakePoint(minute_x, minute_y);
   [self setNeedsDisplay: YES];
}

@end
